import _m0 from "protobufjs/minimal";
import { ConnectionChannelID } from "./connection_channel_id";
import { ConsumerClientID } from "./consumer_client_id";
import { MonitoringInfo } from "./monitoring_info";
import { Params } from "./params";
export declare const protobufPackage = "tendermint.spn.monitoringp";
export interface QueryGetConsumerClientIDRequest {
}
export interface QueryGetConsumerClientIDResponse {
    ConsumerClientID: ConsumerClientID | undefined;
}
export interface QueryGetConnectionChannelIDRequest {
}
export interface QueryGetConnectionChannelIDResponse {
    ConnectionChannelID: ConnectionChannelID | undefined;
}
export interface QueryGetMonitoringInfoRequest {
}
export interface QueryGetMonitoringInfoResponse {
    MonitoringInfo: MonitoringInfo | undefined;
}
/** QueryParamsRequest is request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}
/** QueryParamsResponse is response type for the Query/Params RPC method. */
export interface QueryParamsResponse {
    params: Params | undefined;
}
export declare const QueryGetConsumerClientIDRequest: {
    encode(_: QueryGetConsumerClientIDRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetConsumerClientIDRequest;
    fromJSON(_: any): QueryGetConsumerClientIDRequest;
    toJSON(_: QueryGetConsumerClientIDRequest): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): QueryGetConsumerClientIDRequest;
};
export declare const QueryGetConsumerClientIDResponse: {
    encode(message: QueryGetConsumerClientIDResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetConsumerClientIDResponse;
    fromJSON(object: any): QueryGetConsumerClientIDResponse;
    toJSON(message: QueryGetConsumerClientIDResponse): unknown;
    fromPartial<I extends {
        ConsumerClientID?: {
            clientID?: string;
        };
    } & {
        ConsumerClientID?: {
            clientID?: string;
        } & {
            clientID?: string;
        } & { [K in Exclude<keyof I["ConsumerClientID"], "clientID">]: never; };
    } & { [K_1 in Exclude<keyof I, "ConsumerClientID">]: never; }>(object: I): QueryGetConsumerClientIDResponse;
};
export declare const QueryGetConnectionChannelIDRequest: {
    encode(_: QueryGetConnectionChannelIDRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetConnectionChannelIDRequest;
    fromJSON(_: any): QueryGetConnectionChannelIDRequest;
    toJSON(_: QueryGetConnectionChannelIDRequest): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): QueryGetConnectionChannelIDRequest;
};
export declare const QueryGetConnectionChannelIDResponse: {
    encode(message: QueryGetConnectionChannelIDResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetConnectionChannelIDResponse;
    fromJSON(object: any): QueryGetConnectionChannelIDResponse;
    toJSON(message: QueryGetConnectionChannelIDResponse): unknown;
    fromPartial<I extends {
        ConnectionChannelID?: {
            channelID?: string;
        };
    } & {
        ConnectionChannelID?: {
            channelID?: string;
        } & {
            channelID?: string;
        } & { [K in Exclude<keyof I["ConnectionChannelID"], "channelID">]: never; };
    } & { [K_1 in Exclude<keyof I, "ConnectionChannelID">]: never; }>(object: I): QueryGetConnectionChannelIDResponse;
};
export declare const QueryGetMonitoringInfoRequest: {
    encode(_: QueryGetMonitoringInfoRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetMonitoringInfoRequest;
    fromJSON(_: any): QueryGetMonitoringInfoRequest;
    toJSON(_: QueryGetMonitoringInfoRequest): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): QueryGetMonitoringInfoRequest;
};
export declare const QueryGetMonitoringInfoResponse: {
    encode(message: QueryGetMonitoringInfoResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetMonitoringInfoResponse;
    fromJSON(object: any): QueryGetMonitoringInfoResponse;
    toJSON(message: QueryGetMonitoringInfoResponse): unknown;
    fromPartial<I extends {
        MonitoringInfo?: {
            transmitted?: boolean;
            signatureCounts?: {
                blockCount?: number;
                counts?: {
                    opAddress?: string;
                    RelativeSignatures?: string;
                }[];
            };
        };
    } & {
        MonitoringInfo?: {
            transmitted?: boolean;
            signatureCounts?: {
                blockCount?: number;
                counts?: {
                    opAddress?: string;
                    RelativeSignatures?: string;
                }[];
            };
        } & {
            transmitted?: boolean;
            signatureCounts?: {
                blockCount?: number;
                counts?: {
                    opAddress?: string;
                    RelativeSignatures?: string;
                }[];
            } & {
                blockCount?: number;
                counts?: {
                    opAddress?: string;
                    RelativeSignatures?: string;
                }[] & ({
                    opAddress?: string;
                    RelativeSignatures?: string;
                } & {
                    opAddress?: string;
                    RelativeSignatures?: string;
                } & { [K in Exclude<keyof I["MonitoringInfo"]["signatureCounts"]["counts"][number], keyof import("../types/monitoring").SignatureCount>]: never; })[] & { [K_1 in Exclude<keyof I["MonitoringInfo"]["signatureCounts"]["counts"], keyof {
                    opAddress?: string;
                    RelativeSignatures?: string;
                }[]>]: never; };
            } & { [K_2 in Exclude<keyof I["MonitoringInfo"]["signatureCounts"], keyof import("../types/monitoring").SignatureCounts>]: never; };
        } & { [K_3 in Exclude<keyof I["MonitoringInfo"], keyof MonitoringInfo>]: never; };
    } & { [K_4 in Exclude<keyof I, "MonitoringInfo">]: never; }>(object: I): QueryGetMonitoringInfoResponse;
};
export declare const QueryParamsRequest: {
    encode(_: QueryParamsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): QueryParamsRequest;
};
export declare const QueryParamsResponse: {
    encode(message: QueryParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): unknown;
    fromPartial<I extends {
        params?: {
            lastBlockHeight?: number;
            consumerChainID?: string;
            consumerConsensusState?: {
                nextValidatorsHash?: string;
                timestamp?: string;
                root?: {
                    hash?: string;
                };
            };
            consumerUnbondingPeriod?: number;
            consumerRevisionHeight?: number;
        };
    } & {
        params?: {
            lastBlockHeight?: number;
            consumerChainID?: string;
            consumerConsensusState?: {
                nextValidatorsHash?: string;
                timestamp?: string;
                root?: {
                    hash?: string;
                };
            };
            consumerUnbondingPeriod?: number;
            consumerRevisionHeight?: number;
        } & {
            lastBlockHeight?: number;
            consumerChainID?: string;
            consumerConsensusState?: {
                nextValidatorsHash?: string;
                timestamp?: string;
                root?: {
                    hash?: string;
                };
            } & {
                nextValidatorsHash?: string;
                timestamp?: string;
                root?: {
                    hash?: string;
                } & {
                    hash?: string;
                } & { [K in Exclude<keyof I["params"]["consumerConsensusState"]["root"], "hash">]: never; };
            } & { [K_1 in Exclude<keyof I["params"]["consumerConsensusState"], keyof import("../types/ibc").ConsensusState>]: never; };
            consumerUnbondingPeriod?: number;
            consumerRevisionHeight?: number;
        } & { [K_2 in Exclude<keyof I["params"], keyof Params>]: never; };
    } & { [K_3 in Exclude<keyof I, "params">]: never; }>(object: I): QueryParamsResponse;
};
/** Query defines the gRPC querier service. */
export interface Query {
    /** Queries a ConsumerClientID by index. */
    ConsumerClientID(request: QueryGetConsumerClientIDRequest): Promise<QueryGetConsumerClientIDResponse>;
    /** Queries a ConnectionChannelID by index. */
    ConnectionChannelID(request: QueryGetConnectionChannelIDRequest): Promise<QueryGetConnectionChannelIDResponse>;
    /** Queries a MonitoringInfo by index. */
    MonitoringInfo(request: QueryGetMonitoringInfoRequest): Promise<QueryGetMonitoringInfoResponse>;
    /** Params queries the parameters of the module. */
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: Rpc);
    ConsumerClientID(request: QueryGetConsumerClientIDRequest): Promise<QueryGetConsumerClientIDResponse>;
    ConnectionChannelID(request: QueryGetConnectionChannelIDRequest): Promise<QueryGetConnectionChannelIDResponse>;
    MonitoringInfo(request: QueryGetMonitoringInfoRequest): Promise<QueryGetMonitoringInfoResponse>;
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
declare type KeysOfUnion<T> = T extends T ? keyof T : never;
export declare type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
